%global _hardened_build 1
%global commit 32d9850263ad10be75d967d495e236392fac32a1

Name:           zerotier-one
Version:        1.1.5
Release:        0.11%{?dist}
Summary:        ZeroTier is a software defined networking layer for Earth

License:        GPLv3
URL:            https://zerotier.com
Source0:        https://github.com/zerotier/ZeroTierOne/archive/%{commit}.tar.gz

# hack to solve the problem with compiler flags RPM_OPT_FLAGS and RPM_LD_FLAGS,
# upstream can probably do a better job
Patch0:         %{name}-fix-compiler-linker-flags.patch

#Requires:       miniupnpc >= 2.0
Requires:       http-parser
Requires:       lz4

%if 0%{?fedora}
Requires:       json-parser
%endif

#Requires:       libnatpmp
Requires:       sqlite
#BuildRequires:  miniupnpc-devel >= 2.0
BuildRequires:  http-parser
BuildRequires:  lz4-devel

%if 0%{?fedora}
BuildRequires:  json-parser-devel
%endif

BuildRequires:  libnatpmp-devel
BuildRequires:  sqlite-devel

# EPEL does not have rubygem-conn, proposed to upstream to generate manpages
# for releases and only require this for devel branch of ZT
%if 0%{?fedora}
BuildRequires:  rubygem-ronn
%endif 

%{?systemd_requires}
BuildRequires:  systemd

# https://bugzilla.redhat.com/show_bug.cgi?id=1343238
Provides:       bundled(miniupnpc) = 2.0
%if 0%{?rhel}
# requested EPEL build of json-parser in pkgdb
Provides:       bundled(json-parser) = 1.1.0
%endif

%description
ZeroTier is a software defined networking layer for Earth.

It can be used for on-premise network virtualization, as a peer to peer VPN 
for mobile teams, for hybrid or multi-data-center cloud deployments, or just 
about anywhere else secure software defined virtual networking is useful.

ZeroTier One is our OS-level client service. It allows Mac, Linux, Windows, 
FreeBSD, and soon other types of clients to join ZeroTier virtual networks 
like conventional VPNs or VLANs. It can run on native systems, VMs, or 
containers (Docker, OpenVZ, etc.).

%prep
%setup -qn ZeroTierOne-%{commit} 
%patch0 -p1

%build
make ZT_ENABLE_NETWORK_CONTROLLER=1 ZT_USE_MINIUPNPC=1 %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# systemd service file
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
cp debian/zerotier-one.service $RPM_BUILD_ROOT%{_unitdir}/%{name}.service

%post
%systemd_post zerotier-one.service

%preun
%systemd_preun zerotier-one.service

%postun
%systemd_postun_with_restart zerotier-one.service

%files
%{_sbindir}/*
# XXX do not want stuff in /usr/bin?
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man8/*
%{_unitdir}/%{name}.service
%{_sharedstatedir}/%{name}
%doc AUTHORS.md README.md
%license LICENSE.GPL-3

%changelog
* Thu Jun 23 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.11
- it seems you cannot use negate for conditionals, oh well

* Thu Jun 23 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.10
- do not require rubygem-ronn on EPEL, does not exist, generating manpage
  will just fail, for now manpages will be garbage on EPEL
- hopefully finally fix conditionals now

* Thu Jun 23 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.9
- fix macro conditionals for rhel bundling json-parser
- update to 32d9850263ad10be75d967d495e236392fac32a1
- add RPM_OPT_FLAGS and RPM_LD_FLAGS to the provided makefile to force using
  rpmbuild compiler flags, also disable stripping binary for now
- no longer enable debug build

* Thu Jun 23 2016 François Kooman - 1.1.5-0.8
- update to 0ad6b4105a50bc081ac1c8bd4e4ffe656b8f0b26
- switch back to included build system away from cmake

* Wed Jun 22 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.7
- update to f765597526d698d8ad641ba93e2af5d73612d1e3

* Tue Jun 21 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.6
- fix systemd handling

* Tue Jun 21 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.5
- update to 51ced0cf41b857e7e91413604af6a8e94349649c
- patch for miniupnpc no longer needed

* Tue Jun 21 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.4
- require sqlite
- point to commit instead of branch
- include manpage
- update cmake build file to also build controller by default

* Wed Jun 08 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.3
- include systemd unit file

* Wed Jun 08 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.2
- add libnatpmp as (build)dependency

* Wed Jun 08 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.1
- initial package
